#ifndef _XKB_H
#define _XKB_H

extern int ProcXkbUseExtension(ClientPtr client);
extern int ProcXkbSelectEvents(ClientPtr client);
extern int ProcXkbBell(ClientPtr client);
extern int ProcXkbGetState(ClientPtr client);
extern int ProcXkbLatchLockState(ClientPtr client);
extern int ProcXkbGetControls(ClientPtr client);
extern int ProcXkbSetControls(ClientPtr client);
extern int ProcXkbGetMap(ClientPtr client);
extern int ProcXkbSetMap(ClientPtr client);
extern int ProcXkbGetCompatMap(ClientPtr client);
extern int ProcXkbSetCompatMap(ClientPtr client);
extern int ProcXkbGetIndicatorState(ClientPtr client);
extern int ProcXkbGetIndicatorMap(ClientPtr client);
extern int ProcXkbSetIndicatorMap(ClientPtr client);
extern int ProcXkbGetNamedIndicator(ClientPtr client);
extern int ProcXkbSetNamedIndicator(ClientPtr client);
extern int ProcXkbGetNames(ClientPtr client);
extern int ProcXkbSetNames(ClientPtr client);
extern int ProcXkbGetGeometry(ClientPtr client);
extern int ProcXkbSetGeometry(ClientPtr client);
extern int ProcXkbPerClientFlags(ClientPtr client);
extern int ProcXkbListComponents(ClientPtr client);
extern int ProcXkbGetKbdByName(ClientPtr client);
extern int ProcXkbGetDeviceInfo(ClientPtr client);
extern int ProcXkbSetDeviceInfo(ClientPtr client);
extern int ProcXkbSetDebuggingFlags(ClientPtr client);

extern void XkbExtensionInit(void);

extern Bool XkbFilterEvents(ClientPtr pClient, int nEvents, xEvent *xE);

extern Bool XkbCopyKeymap(
    XkbDescPtr              src,
    XkbDescPtr              dst,
    Bool                    sendNotifies);

extern Bool XkbWriteKeymapForNames(
    void *		/* cookie */,
    XkbComponentNamesPtr/* names */,
    XkbDescPtr		/* xkb */,
    unsigned		/* want */,
    unsigned		/* need */
);

#ifdef __GNUC__
#define PRINTF_FORMAT	__attribute__ ((format (printf, 2, 3)))
#else
#define PRINTF_FORMAT	/**/
#endif
extern int Xkb_printf(
    void *		/* cookie */,
    const char *	/* format */,
    ...
)  PRINTF_FORMAT;
#undef PRINTF_FORMAT
#define xkb_printf	Xkb_printf

extern void *Xkb_xkbcomp_init(
    void
);

extern void Xkb_xkbcomp_final(
    char [PATH_MAX]	/* name */,
    unsigned char [42]	/* sha1 */,
    char *		/* ext */
);

typedef void (*XkbCookieAddOnFunc)(
    void *		/* cookie */,
    XkbDescPtr		/* result */,
    Bool		/* topLevel */,
    Bool		/* showImplicit */,
    int			/* fileSection */,
    void *		/* priv */
);

extern Bool XkbWrite_Keycodes(
    void *		/* file */,
    XkbDescPtr		/* result */,
    Bool		/* topLevel */,
    Bool		/* showImplicit */,
    XkbCookieAddOnFunc	/* addOn */,
    void *		/* priv */
);

extern Bool XkbWrite_KeyTypes(
    void *		/* cookie */,
    XkbDescPtr		/* result */,
    Bool		/* topLevel */,
    Bool		/* showImplicit */,
    XkbCookieAddOnFunc	/* addOn */,
    void *		/* priv */
);

extern Bool XkbWrite_CompatMap(
    void *		/* cookie */,
    XkbDescPtr		/* result */,
    Bool		/* topLevel */,
    Bool		/* showImplicit */,
    XkbCookieAddOnFunc	/* addOn */,
    void *		/* priv */
);

extern Bool XkbWrite_Symbols(
    void *		/* cookie */,
    XkbDescPtr		/* result */,
    Bool		/* topLevel */,
    Bool		/* showImplicit */,
    XkbCookieAddOnFunc	/* addOn */,
    void *		/* priv */
);

Bool
XkbWrite_Geometry(
    void *		/* cookie */,
    XkbDescPtr		/* result */,
    Bool		/* topLevel */,
    Bool		/* showImplicit */,
    XkbCookieAddOnFunc	/* addOn */,
    void *		/* priv */
);

#endif
